#include "compute_state_dieterich_common.hh"

DieterichNonlinearity::DieterichNonlinearity(double _VoL) : VoL(_VoL) {}

void DieterichNonlinearity::directionalSubDiff(VectorType const &u,
                                               VectorType const &v,
                                               Interval<double> &D) const {
  D[0] = D[1] = v[0] * (VoL - std::exp(-u[0]));
}

void DieterichNonlinearity::directionalDomain(VectorType const &,
                                              VectorType const &,
                                              Interval<double> &dom) const {
  dom[0] = -std::numeric_limits<double>::max();
  dom[1] = std::numeric_limits<double>::max();
}
