#include <dune/common/fvector.hh>
#include <dune/common/fmatrix.hh>
#include <dune/fufem/interval.hh>

class DieterichNonlinearity {
public:
  using VectorType = Dune::FieldVector<double, 1>;
  using MatrixType = Dune::FieldMatrix<double, 1, 1>;

  DieterichNonlinearity(double _VoL);
  void directionalSubDiff(VectorType const &u, VectorType const &v,
                          Interval<double> &D) const;
  void directionalDomain(VectorType const &, VectorType const &,
                         Interval<double> &dom) const;

private:
  double const VoL;
};
